//-------------------------------------------------------------------
//  File:   OGLCMainHeader.h
//  Time:   July 15, 2000
//  Author:   Aaron Hilton (OTri Studios)
//  Comments: OpenGL Challenge application functions and variables
//            used to bind the platform specific parts to the visual
//            code.
//-------------------------------------------------------------------
#ifndef __OGLCMainHeader_h_
#define __OGLCMainHeader_h_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Functions implemented by the author in YourCode.cpp
bool appPreInit();  // Initialize before OpenGL has been initialized.
bool appInit();     // Initialize after OpenGL has been initialized.
bool appRender();   // Update/Render a frame. Return false to exit.
void appShutdown(); // Take down any textures, timers, sounds, etc...

// Return a null terminated string.
char *appGetAuthor();        // You, the author.
char *appGetName();          // Your work's new name.
char *appGetDescription();   // A quick description of what it is.
char *appGetTitleBar();      // The title bar refreshes every half sec.

void appKeyDown(int k);
void appKeyUp(int k);
void appKeyChar(int k);

// These values are maintained by the platform
// side of the OpenGL Challenge framework. Do Not Modify.
extern UInt32 sys_glWidth, sys_glHeight;
extern UInt8  sys_glBPP;
extern UInt32 sys_Time; // Time counted in milliseconds (1/1000 sec).

#endif // __OGLCMainHeader_h_
